"use strict";
exports.__esModule = true;
exports.useConnection = void 0;
var tslib_1 = require("tslib");
/* eslint-disable @typescript-eslint/no-empty-function */
var react_1 = tslib_1.__importStar(require("react"));
var react_use_websocket_1 = tslib_1.__importStar(require("react-use-websocket"));
var ConnectionState;
(function (ConnectionState) {
    ConnectionState["CONNECTING"] = "Connecting";
    ConnectionState["OPEN"] = "Open";
    ConnectionState["CLOSING"] = "Closing";
    ConnectionState["CLOSED"] = "Closed";
    ConnectionState["UNINSTANTIATED"] = "Uninstantiated";
})(ConnectionState || (ConnectionState = {}));
var ConnectionContext = (0, react_1.createContext)({
    connectionStatus: ConnectionState.UNINSTANTIATED,
    sendMessage: function () { },
    lastMessage: null,
    changeConnectionUrl: function () { }
});
var ConnectionProvider = function (_a) {
    var _b;
    var children = _a.children, socketUrl = _a.socketUrl, options = _a.options;
    var _c = (0, react_1.useState)(socketUrl), connectionUrl = _c[0], setConnectionUrl = _c[1];
    var _d = (0, react_use_websocket_1["default"])(connectionUrl, options), readyState = _d.readyState, sendJsonMessage = _d.sendJsonMessage, lastJsonMessage = _d.lastJsonMessage;
    (0, react_1.useEffect)(function () {
        if (socketUrl !== connectionUrl)
            setConnectionUrl(socketUrl);
    }, [connectionUrl, socketUrl]);
    var changeConnectionUrl = (0, react_1.useCallback)(function (url) {
        setConnectionUrl(url);
    }, []);
    var sendMessage = (0, react_1.useCallback)(function (message) {
        sendJsonMessage(message);
    }, [sendJsonMessage]);
    var connectionStatus = (_b = {},
        _b[react_use_websocket_1.ReadyState.CONNECTING] = ConnectionState.CONNECTING,
        _b[react_use_websocket_1.ReadyState.OPEN] = ConnectionState.OPEN,
        _b[react_use_websocket_1.ReadyState.CLOSING] = ConnectionState.CLOSING,
        _b[react_use_websocket_1.ReadyState.CLOSED] = ConnectionState.CLOSED,
        _b[react_use_websocket_1.ReadyState.UNINSTANTIATED] = ConnectionState.UNINSTANTIATED,
        _b)[readyState];
    var contextValue = (0, react_1.useMemo)(function () {
        return {
            connectionStatus: connectionStatus,
            changeConnectionUrl: changeConnectionUrl,
            sendMessage: sendMessage,
            lastMessage: lastJsonMessage
        };
    }, [changeConnectionUrl, connectionStatus, lastJsonMessage, sendMessage]);
    var Provider = ConnectionContext.Provider;
    return react_1["default"].createElement(Provider, { value: contextValue }, children);
};
var useConnection = function () { return (0, react_1.useContext)(ConnectionContext); };
exports.useConnection = useConnection;
exports["default"] = ConnectionProvider;
//# sourceMappingURL=ConnectionProvider.js.map