/* eslint-disable @typescript-eslint/no-empty-function */
import React, { createContext, useCallback, useContext, useEffect, useMemo, useState } from "react";
import useWebSocket, { ReadyState } from "react-use-websocket";
var ConnectionState;
(function (ConnectionState) {
    ConnectionState["CONNECTING"] = "Connecting";
    ConnectionState["OPEN"] = "Open";
    ConnectionState["CLOSING"] = "Closing";
    ConnectionState["CLOSED"] = "Closed";
    ConnectionState["UNINSTANTIATED"] = "Uninstantiated";
})(ConnectionState || (ConnectionState = {}));
var ConnectionContext = createContext({
    connectionStatus: ConnectionState.UNINSTANTIATED,
    sendMessage: function () { },
    lastMessage: null,
    changeConnectionUrl: function () { }
});
var ConnectionProvider = function (_a) {
    var _b;
    var children = _a.children, socketUrl = _a.socketUrl, options = _a.options;
    var _c = useState(socketUrl), connectionUrl = _c[0], setConnectionUrl = _c[1];
    var _d = useWebSocket(connectionUrl, options), readyState = _d.readyState, sendJsonMessage = _d.sendJsonMessage, lastJsonMessage = _d.lastJsonMessage;
    useEffect(function () {
        if (socketUrl !== connectionUrl)
            setConnectionUrl(socketUrl);
    }, [connectionUrl, socketUrl]);
    var changeConnectionUrl = useCallback(function (url) {
        setConnectionUrl(url);
    }, []);
    var sendMessage = useCallback(function (message) {
        sendJsonMessage(message);
    }, [sendJsonMessage]);
    var connectionStatus = (_b = {},
        _b[ReadyState.CONNECTING] = ConnectionState.CONNECTING,
        _b[ReadyState.OPEN] = ConnectionState.OPEN,
        _b[ReadyState.CLOSING] = ConnectionState.CLOSING,
        _b[ReadyState.CLOSED] = ConnectionState.CLOSED,
        _b[ReadyState.UNINSTANTIATED] = ConnectionState.UNINSTANTIATED,
        _b)[readyState];
    var contextValue = useMemo(function () {
        return {
            connectionStatus: connectionStatus,
            changeConnectionUrl: changeConnectionUrl,
            sendMessage: sendMessage,
            lastMessage: lastJsonMessage
        };
    }, [changeConnectionUrl, connectionStatus, lastJsonMessage, sendMessage]);
    var Provider = ConnectionContext.Provider;
    return React.createElement(Provider, { value: contextValue }, children);
};
export var useConnection = function () { return useContext(ConnectionContext); };
export default ConnectionProvider;
//# sourceMappingURL=ConnectionProvider.js.map